#!/usr/bin/env python
# -*- coding: utf-8 -*-
import random
import pickle
from extractor import *

anzahl_reimpaare = int(raw_input("Geben Sie die Anzahl der Reime an: "))
laenge_einer_zeile = int(raw_input("Geben Sie die Anzahl der Silben pro Zeile an: "))+1
toleranz_laenge_der_zeile = int(raw_input("Geben Sie die Toleranz zur Laenge einer Zeile an: "))+1
anzahl_der_strophen = int(raw_input("Geben Sie die Anzahl der Strophen an: "))
reimschema = str(raw_input("Geben Sie ein Reimschema aabb, abab oder abba an: "))
#Vorschlag für eine gute Verteilung:
# anzahl_reimpaare = 8
# print "Anzahl der Reime: ", anzahl_reimpaare
# laenge_einer_zeile = 5
# print "Laenge einer Zeile: ", laenge_einer_zeile
# toleranz_laenge_der_zeile = 2
# print "Toleranz fuer die Laenge einer Zeile: ", toleranz_laenge_der_zeile
# anzahl_der_strophen = 4
# print "Anzahl der Strophen: ", anzahl_der_strophen
# reimschema = "abba"
# print "Reimschema: ", reimschema
eingabe1 = read_songs("bobdylan.dump")


### UMWANDELN VON TEXT-DATEIEN IN EINE FÜR DEN CODE VERARBEITBARE FORM ###


def txt_einlese_fertig():
	with open ("stjamesbible.txt", "r") as eingabe_text:
		text = eingabe_text.read()
	liste_mit_strings = [text]
	import re
	text=re.sub(r'[^\x00-\x7F]','', text) # bsp: nimmt alle a-j raus und tut ! an ihre stelle: sub(r"["a"-"j"]","!",dateiname) 
	for i in range(10):
		i = str(i)
		neue_liste_mit_strings=[]
		for liste in liste_mit_strings:
			neue_liste_mit_strings.extend(liste.split(i))
		liste_mit_strings=neue_liste_mit_strings
	return liste_mit_strings
eingabe2 = txt_einlese_fertig()
print "Zeilenenden: Eminem, alles davor: Bibel"


### AUFTEILEN DES ERSTEN EINGABETEXTES IN ABSÄTZE UND EINLESEN DER JEWEILS LETZTEN WÖRTER EINES ABSATZES ###


liste_mit_eingegebenen_zeilen = []
ngrams = {}
def letztewoerter():
	global liste_mit_eingegebenen_zeilen
	for x in range(0, len(eingabe1)):
			eingabe_ohne_zeichen = eingabe1[x].lyrics.replace("."," ").replace(","," ").replace("!"," ").replace("?"," ").replace(";"," ").replace("("," ").replace(")"," ").replace("-"," ").replace('"'," ")
			eingabe_ohne_zeichen = eingabe_ohne_zeichen.lower()
			liste_mit_eingegebenen_zeilen.extend(eingabe_ohne_zeichen.split("\n"))
	liste_2=[]
	for zeile in liste_mit_eingegebenen_zeilen:
		liste_2.append(zeile.split())
	liste_mit_eingegebenen_zeilen=liste_2
	for x in range(0, len(liste_mit_eingegebenen_zeilen)):
		try:
			if liste_mit_eingegebenen_zeilen[x][-1] not in ngrams:
				try:
					ngrams[liste_mit_eingegebenen_zeilen[x][-1]] = [liste_mit_eingegebenen_zeilen[x+1][-1]]
					ngrams[liste_mit_eingegebenen_zeilen[x][-1]].append(liste_mit_eingegebenen_zeilen[x+2][-1])
				except IndexError:
					continue
		except:
			continue
		try:	
			if liste_mit_eingegebenen_zeilen[x][-1] in ngrams:
				try:
					ngrams[liste_mit_eingegebenen_zeilen[x][-1]].append(liste_mit_eingegebenen_zeilen[x+1][-1])
					ngrams[liste_mit_eingegebenen_zeilen[x][-1]].append(liste_mit_eingegebenen_zeilen[x+2][-1])
				except IndexError:
					continue
		except:
			continue
	return ngrams

ngrams=letztewoerter()


### UMWANDELN DER ORIGINALEN PHONEME DER WORTE IM REIMPOOL IN ALLGEMEINERE PHONEME ###


f=file("cmudict.dump","rb")
p=pickle.Unpickler(f)
betonungen=p.load()
dictionary = dict(betonungen)
worte = []
for listen in ngrams:
	worte.append(listen)

def toleranz_wort(wort):
	toleranz = {
	("G", "K", "C"): ["K"], 
	("F", "V"): ["F"], 
	("D", "T"): ["T"], 
	("OW1", "OW0"): ["OW"], 
	("AW1",): ["AO"],
	("EH1","EH2", "AE1", "EH0", "AE0"): ["AE"], 
	("AH1", "AA1", "AA2"): ["A"],  
	("EY1",): ["AY"], 
	("AY1",): ["AI"],
	("SH",): ["SH"],
	("N",): ["N"],
	("NG",): ["NG"],
	("M",): ["M"],
	("B",): ["B"],
	("L",): ["L"],
	("AO1",): ["Ooffen"],
	("DH", "TH"): ["TH"],
	("P",): ["P"],
	("Y",): ["Y"],
	("W", "V"): ["W"],
	("IH0", "IH1", "IY0", "IY1", "IH2"): ["I"], 
	("ER2", "ER1"): ["E","R"], 
	("R",): ["R"],
	("ER0",): ["O","R"], 
	("S", "Z"): ["S"], 
	("HH",): ["H"],
	("JH", "CH"): ["TSCH"],
	("UW1", "UW0", "AH0"): ["U"]}

	vokale = ["A", "E", "I", "O", "U", "AE", "ER", "OR", "OW", "AY", "Ooffen", "AO", "AI"]
	altes_wort = dictionary[wort]
	neues_wort=[]
	for i in range(len(altes_wort)):
		for key in toleranz.keys():
			for phonem in key:
				if altes_wort[i] == phonem:
					for laut in toleranz[key]:
						neues_wort.append(laut)
				else: 
					continue
	for j in range(len(neues_wort)):
		try:
			if neues_wort[j] == "R" and neues_wort[j+1] not in vokale:
				neues_wort.remove(neues_wort[j])
			elif neues_wort[-1] == "R":
				neues_wort.remove(neues_wort[-1])
		except IndexError:
			pass
	return neues_wort


### FESTSTELLUNG DER ANZAHL DER SILBEN ZUM VERGLEICHEN DER REIME ###


def silbenzahl(neues_wort):
	vokale = ["A", "E", "I", "O", "U", "AE", "ER", "OR", "OW", "AY", "Ooffen", "AO", "AI"]
	x = 0
	for letter in neues_wort:
		if letter in vokale:
			x = x +1
	return x


###VERGLEICHEN ALLER WÖRTER AUF REIME UND IHRE SPEICHERUNG MIT IHREN MÖGLICHEN REIMPARTNERN ###


def silben(neues_wort, anzahl_silben):
	vokale = ["A", "E", "I", "O", "U", "AE", "ER", "OR", "OW", "AY", "Ooffen", "AO", "AI"]
	silbe = [] 
	# hilfslist_fuer_mehrere_silben = []
	# hilfslist_fuer_viele_silben = []
	# hilfslist_fuer_eine_silbe = []
	hilfsliste = []
	for x in range(len(neues_wort)+1)[1:]:
		if 4 > anzahl_silben:
			try:
				if neues_wort[-x] in vokale and neues_wort[-(x+1)] not in vokale and neues_wort[-(x+2)]:
					hilfsliste.append(neues_wort[-(x):])
				elif neues_wort[-x] in vokale and neues_wort[-(x+1)] in vokale and neues_wort[-(x+2)]:
					hilfsliste.append(neues_wort[-x:])
			except IndexError:
				if neues_wort[-(x+1)]not in vokale:
					hilfsliste.append(neues_wort[-x:])
			try:
				silbe = hilfsliste[-1]
			except IndexError:
				pass
		elif anzahl_silben > 3:
			try:
				if neues_wort[-x] in vokale and neues_wort[-(x+1)] not in vokale:
					hilfsliste.append(neues_wort[-(x):])
				elif neues_wort[-x] in vokale and neues_wort[-(x+1)] in vokale:
					hilfsliste.append(neues_wort[-x:])
			except IndexError:
				pass
			try:
				silbe = hilfsliste[1]
			except IndexError:
				pass
		else:
			if neues_wort[-x] in vokale:
				hilfslist_fuer_eine_silbe.append(neues_wort[-x:])
			try:
				silbe = hilfslist_fuer_eine_silbe[0]
			except IndexError:
				pass
	return silbe

def funktionen_aufrufen(worte):
	i = 1
	endungen = {}
	while i < len(worte):
		wort = worte[i]
		try:
			if not (wort in dictionary):
				i=i+1
				continue
			neues_wort = toleranz_wort(wort)
			anzahl_silben = silbenzahl(neues_wort)
			endsilben = silben(neues_wort, anzahl_silben)
			i = i +1
		except IndexError:
			i=i+1
		endungen[wort] = endsilben
	return endungen

endungen = funktionen_aufrufen(worte)


### ZUFÄLLIGES AUSWÄHLEN DER REIMPAARE UND ANORDNEN DIESER JE NACH REIMSCHEMA ###


def reime_finden(endungen, worte):
	reime ={}
	for wort1 in worte:
		for wort2 in worte:
			if wort1 != wort2:
				if (not ( wort1 in endungen)) or (not (wort2 in endungen)):
					continue
				if len(endungen[wort1]) <= len(endungen[wort2]):
					m = len(endungen[wort1])
					if endungen[wort1][-m:] == endungen[wort2][-m:]:
						if not reime.has_key(tuple(endungen[wort1])) and not reime.has_key(tuple(endungen[wort2])):
							reime[tuple(endungen[wort1])] = [wort2]
							reime[tuple(endungen[wort1])].append(wort1)
						elif reime.has_key(tuple(endungen[wort1])) :
							reime[tuple(endungen[wort1])].append(wort2)
				elif len(endungen[wort1]) > len(endungen[wort2]):
					m = len(endungen[wort2])
					if endungen[wort1][-m:] == endungen[wort2][-m:]:
						if not reime.has_key(tuple(endungen[wort1])) and not reime.has_key(tuple(endungen[wort2])):
							reime[tuple(endungen[wort1])] = [wort2]
							reime[tuple(endungen[wort1])].append(wort1)
						elif reime.has_key(tuple(endungen[wort1])):
							reime[tuple(endungen[wort1])].append(wort2)
	return reime

reime = reime_finden(endungen, worte)


###ERSTELLEN DER WAHRSCHEINLICHKEITEN FÜR DIE 2-GRAMMS DER ZEILENGENERIERUNG AUS DEM ZWEITEN EINGABETEXT ###


def endreimerueckgabe(reime):
 	global reimschema
	endreime = []
	i = 0
	while i < len(reime):
		try:
			if reime[reime.keys()[i]][0] != reime[reime.keys()[i]][1]:
				endreime.append(reime[reime.keys()[i]][0])
				endreime.append(reime[reime.keys()[i]][1])
				i = i+1
			elif reime[reime.keys()[i]][0] == reime[reime.keys()[i]][1]:
				if reime[reime.keys()[i]][0] != reime[reime.keys()[i]][2]:
					endreime.append(reime[reime.keys()[i]][1])
					endreime.append(reime[reime.keys()[i]][2])
					i = i+1
				elif reime[reime.keys()[i]][0] == reime[reime.keys()[i]][2]:
					i = i+1
					pass
		except IndexError:
			pass
	endreimeneu = []
	while reimschema not in ["aabb", "abab", "abba"]:
		reimschema = str(raw_input("Sie müssen eins dieser drei Reimschemata angeben: aabb, abab oder abba: "))
	if reimschema == "aabb":
		for x in range(anzahl_reimpaare): 
			a = random.randint(0, len(endreime)//2)*2
			endreimeneu.append(endreime[a])
			endreimeneu.append(endreime[a+1])
	elif reimschema == "abab":
		for x in range(anzahl_reimpaare): 
			a = random.randint(0, len(endreime)//2)*2
			b = random.randint(0, len(endreime)//2)*2
			if a != b:
				endreimeneu.append(endreime[a])
				endreimeneu.append(endreime[b])
				endreimeneu.append(endreime[a+1])
				endreimeneu.append(endreime[b+1])
			elif a == b:
				x = x
	elif reimschema == "abba":
		for x in range(anzahl_reimpaare):
			a = random.randint(0, len(endreime)//2)*2
			b = random.randint(0, len(endreime)//2)*2
			if a != b:
				endreimeneu.append(endreime[a])
				endreimeneu.append(endreime[b])
				endreimeneu.append(endreime[b+1])
				endreimeneu.append(endreime[a+1])
			elif a == b:
				x = x
	return endreimeneu


### WORT-FÜR-WORT ANHÄNGEN AN DIE REIMPAARE ZUR ZEILENGENERIERUNG NACH DEM 2-GRAMM-PRINZIP ###


ngramshinten = {}

def ngramshintenmet():
	liste_ohne_zeichen = []
	liste_ohne_zeichen_gesplittet = []
	for x in range(len(eingabe2)): 
		eingabe_ohne_zeichen =eingabe2[x].replace(".","").replace(",","").replace("!","").replace("?","").replace(";","").replace("("," ").replace(")"," ").replace("-"," ").replace('"'," ")
		eingabe_ohne_zeichen = eingabe_ohne_zeichen.lower()
		liste_ohne_zeichen.append(eingabe_ohne_zeichen.split())
	for x in range(len(liste_ohne_zeichen)):
		liste_ohne_zeichen_gesplittet.extend(liste_ohne_zeichen[x])
	for x in range(len(liste_ohne_zeichen_gesplittet)):
		if not(liste_ohne_zeichen_gesplittet[x] in ngramshinten):
			ngramshinten[liste_ohne_zeichen_gesplittet[x]] = [liste_ohne_zeichen_gesplittet[x-1]]
		else:
			ngramshinten[liste_ohne_zeichen_gesplittet[x]].append(liste_ohne_zeichen_gesplittet[x-1])
	return ngramshinten

ngramshinten_fuer_notfall = {}
def ngramshinten_fuer_notfall_met():
	liste_ohne_zeichen = []
	liste_ohne_zeichen_gesplittet = []
	for x in range(len(eingabe1)):
		eingabe_ohne_zeichen =eingabe1[x].lyrics.replace(".","").replace(",","").replace("!","").replace("?","").replace(";","").replace("("," ").replace(")"," ").replace("-"," ").replace('"'," ")
		eingabe_ohne_zeichen = eingabe_ohne_zeichen.lower()
		liste_ohne_zeichen.append(eingabe_ohne_zeichen.split())
	for x in range(len(liste_ohne_zeichen)):
		liste_ohne_zeichen_gesplittet.extend(liste_ohne_zeichen[x])
	for x in range(len(liste_ohne_zeichen_gesplittet)):
		if not(liste_ohne_zeichen_gesplittet[x] in ngramshinten_fuer_notfall):
			ngramshinten_fuer_notfall[liste_ohne_zeichen_gesplittet[x]] = [liste_ohne_zeichen_gesplittet[x-1]]
		else:
			ngramshinten_fuer_notfall[liste_ohne_zeichen_gesplittet[x]].append(liste_ohne_zeichen_gesplittet[x-1])
	return ngramshinten_fuer_notfall

ngramshinten=ngramshintenmet()

endreime = endreimerueckgabe(reime)


### GENERIERUNG DES FERTIGEN GEDICHTS ###


def alle_Strophen():
	reimende_worte = 2*anzahl_reimpaare
	reime_pro_strophe = reimende_worte//anzahl_der_strophen 
	strophen = [] 
	for y in range(anzahl_der_strophen):
		for x in range(reime_pro_strophe):
			song_zeile = ErsteMet(x+y*reime_pro_strophe,toleranz_laenge_der_zeile)
			strophen.append(song_zeile[0])
		strophen.append(" ")
	strophen = "\n".join(strophen)
	print "\n"
	print strophen

def ErsteMet(x,toleranz_laenge_der_zeile):
	song_zeile=[]
	zeilen = []
	zeilen.append(endreime[x])
	i = silbenzahl(toleranz_wort(endreime[x]))
	while i <= laenge_einer_zeile:
		try:
			vorheriges_wort = random.choice(ngramshinten[zeilen[0]])
		except KeyError:
			ngramshinten_fuer_notfall = ngramshinten_fuer_notfall_met()
			vorheriges_wort = random.choice(ngramshinten_fuer_notfall[zeilen[0]])
		if vorheriges_wort == zeilen[0]:
			i = i
		else:
			try:
				i = i + silbenzahl(toleranz_wort(vorheriges_wort.lower()))
				zeilen.insert(0, vorheriges_wort)
			except KeyError:
				try:
					if silbenzahl(toleranz_wort(vorheriges_wort.lower())) <= toleranz_laenge_der_zeile:
						print "if"
						zeilen.insert(0, vorheriges_wort).join
						i = laenge_einer_zeile + 1
					else:
						print "else"
				except KeyError:
					i = i
	zeilen = " ".join(zeilen)
	zeilen = "".join(zeilen)
	song_zeile.append(zeilen)
	return song_zeile

alle_Strophen()